import { ILayer, Scene } from '@antv/l7';
import { EventEmitter } from 'eventemitter3';
import { IDistrictLayerOption } from './interface';
export default class BaseLayer extends EventEmitter {
    fillLayer: ILayer;
    lineLayer: ILayer;
    labelLayer: ILayer;
    bubbleLayer: ILayer;
    protected scene: Scene;
    protected options: IDistrictLayerOption;
    protected layers: ILayer[];
    protected fillData: any;
    protected layerType: string;
    private popup;
    constructor(scene: Scene, option?: Partial<IDistrictLayerOption>);
    destroy(): void;
    show(): void;
    hide(): void;
    setOption(newOption: {
        [key: string]: any;
    }): void;
    getFillData(): any;
    getOptions(): IDistrictLayerOption;
    updateData(newData?: Array<{
        [key: string]: any;
    }>, joinByField?: [string, string]): void;
    protected fetchData(data: {
        url: any;
        type: string;
    }): Promise<any>;
    protected getDefaultOption(): IDistrictLayerOption;
    protected addFillLayer(fillCountry: any): void;
    protected addFillLine(provinceLine: any): void;
    protected addLabelLayer(labelData: any, type?: string): void;
    protected addBubbleLayer(labelData: any, type?: string): ILayer;
    protected addLabel(labelData: any, type?: string): ILayer;
    protected addPopup(): void;
    private setLayerAttribute;
}
