import { Scene } from '@antv/l7';
import { adcodeType, IDrillDownOption, DRILL_LEVEL } from './interface';
export default class DrillDownLayer {
    drillState: DRILL_LEVEL;
    private options;
    private regionLayer;
    private cityLayer;
    private countyLayer;
    private provinceLayer;
    private scene;
    private layers;
    private drillList;
    constructor(scene: Scene, option: Partial<IDrillDownOption>);
    getDefaultOption(): {
        drillDepth: number;
        drillStart: number;
        customTrigger: boolean;
        autoUpdateData: boolean;
        regionDrill: boolean;
        drillDownTriggerEvent: string;
        drillUpTriggerEvent: string;
        provinceData: never[];
        viewStart: string;
        viewEnd: string;
        cityData: never[];
        countyData: never[];
        city: {
            adcode: never[];
            depth: number;
        };
        region: {
            adcode: never[];
            depth: number;
        };
        county: {
            adcode: never[];
        };
    };
    addCountryEvent(): void;
    addRegionEvent(): void;
    addProvinceEvent(): void;
    addCityEvent(): void;
    show(): void;
    hide(): void;
    destroy(): void;
    showProvinceView(adcode: adcodeType, newData?: Array<{
        [key: string]: any;
    }>, joinByField?: [string, string]): void;
    showCityView(code: adcodeType, newData?: Array<{
        [key: string]: any;
    }>, joinByField?: [string, string]): void;
    showRegionView(adcode: adcodeType, newData?: Array<{
        [key: string]: any;
    }>, joinByField?: [string, string]): void;
    /**
     * 向上
     */
    drillUp(type: DRILL_LEVEL): void;
    drillDown(adcode: adcodeType, newData?: Array<{
        [key: string]: any;
    }>, joinByField?: [string, string]): void;
    updateData(layer: DRILL_LEVEL, newData: Array<{
        [key: string]: any;
    }>, joinByField?: [string, string]): void;
    private getLayerOption;
    private initLayers;
    private initLayerEvent;
    private getViewList;
    private getProperties;
}
