import { Scene } from '@antv/l7';
import BaseLayer from './baseLayer';
import { adcodeType, IDistrictLayerOption } from './interface';
export interface IProvinceLayerOption extends IDistrictLayerOption {
    adcode: adcodeType;
}
export default class ProvinceLayer extends BaseLayer {
    private fillRawData;
    private lineRawData;
    private labelRawData;
    protected layerType: string;
    constructor(scene: Scene, option?: Partial<IProvinceLayerOption>);
    updateDistrict(adcode: adcodeType, newData?: Array<{
        [key: string]: any;
    }>, joinByField?: [string, string]): void;
    protected getDefaultOption(): IProvinceLayerOption;
    protected filterData(data: any, adcode: adcodeType): {
        type: string;
        features: any;
    };
    protected filterLabelData(data: any, adcode: adcodeType): any;
    private addProvinceFillLayer;
    private addProvinceLineLayer;
}
